C--------------------------------------
C Provide to each subprocess function.
C--------------------------------------
      function func(x)
      implicit real*8(a-h,o-z)
      common /amjprc/jproc
      include 'grchad.inc'
      parameter ( mxdim = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      real*8   x(mxdim)
      real*8   xss,xsn(10)

      if (jproc.eq.1) then
         func = fnc400(x)
      else if (jproc.eq.2) then
         func = fnc401(x)
      else if (jproc.eq.3) then
         func = fnc402(x)
      else if (jproc.eq.4) then
         func = fnc403(x)
      else if (jproc.eq.5) then
         func = fnc404(x)
      else if (jproc.eq.6) then
         func = fnc405(x)
      else if (jproc.eq.7) then
         func = fnc406(x)
      else if (jproc.eq.8) then
         func = fnc407(x)
      endif

      return
 999  continue
      yacob = 0.0d0
      func = 0
      return
      end


C-------------------------------
C Kinematics of original GRACE.
C-------------------------------
      SUBROUTINE ARRCLR(A,N)
      REAL*8 A(100)
      IF(N.GT.100) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN 100 ',N
         RETURN
      END IF
      DO 1 I12=1,N
 1       A(I12)=0
      RETURN
      END

      SUBROUTINE ARRCPY(A,B,N)
      REAL*8 A(100),B(100)
      IF(N.GT.100) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN 100 ',N
         RETURN
      END IF
      DO 1 I11=1,N
 1       A(I11)=B(I11)
      RETURN
      END

      FUNCTION DETERM(A,N)
      REAL*8 DETERM,A(100),B(10,10),SAVE
      IF(N.GT.10) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN TEN ',N
         RETURN
      END IF
      DO 1 I12=1,N
         DO 1 I11=1,N
 1          B(I11,I12)=A(I11+N*(I12-1))
      DETERM=1
      DO 2 I2=1,N
         IF(B(I2,I2).EQ.0)THEN
            DO 5 I5=I2,N
               IF(B(I2,I5).EQ.0)THEN
                  DETERM=0
                  RETURN
               ELSE
                  DO 6 I6=I2,N
                     SAVE=B(I6,I5)
                     B(I6,I5)=B(I5,I2)
                     B(I5,I2)=SAVE
 6                CONTINUE
                  DETERM=-DETERM
               END IF
 5          CONTINUE
         END IF
         DETERM=DETERM*B(I2,I2)
         IF(I2.EQ.N) GOTO 2
         DO 3 I3=I2+1,N
            DO 3 I4=I2+1,N
 3             B(I3,I4)=B(I3,I4)-B(I3,I2)*B(I2,I4)/B(I2,I2)
 2    CONTINUE
      RETURN
      END

      subroutine ktolab(p1,p2,p3,p4, p5,p6)
*
      implicit real*8(a-h,o-z)
      real*8 p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)
      real*8 pk2l(4),pl2k(4),rk2l(3,3),rl2k(3,3),pt1(4)
*
      do 1 i=1,4
         pk2l(i)= p2(i)
         pl2k(i)=-p2(i)
 1    continue
      pl2k(4)= p2(4)
*
      call pboost(p1,pl2k, pt1)
      call rotmtx(pt1, rl2k)
      call minvr2(rl2k, rk2l)
*
      call mvmult(rk2l,p3, p5)
      call pboost(p5,pk2l, p5)
      call mvmult(rk2l,p4, p6)
      call pboost(p6,pk2l, p6)
*
      return
      end

      subroutine labtok(p1,p2,p3,p4, p5,p6)
*
      implicit real*8(a-h,o-z)
      real*8 p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)
      real*8 pl2k(4),pt1(4),rl2k(3,3)
*
      do 1 i=1,4
         pl2k(i)=-p2(i)
 1    continue
      pl2k(4)= p2(4)
*
      call pboost(p1,pl2k, pt1)
      call rotmtx(pt1, rl2k)
*
      call pboost(p3,pl2k, p5)
      call mvmult(rl2k,p5, p5)
      call pboost(p4,pl2k, p6)
      call mvmult(rl2k,p6, p6)
*
      return
      end

      SUBROUTINE MEMCLC(R,N1,N2)
      COMPLEX*16 R(9)
      DO 1 I=1,N1
 1       R(I)=N2
      RETURN
      END

      SUBROUTINE MEMCLR(R,N1,N2)
      REAL*8 R(9)
      DO 1 I=1,N1
 1       R(I)=N2
      RETURN
      END

      FUNCTION MINOR(A,N,I,J)
      REAL*8 MINOR,A(100),B(100),DETERM
      IF(N.GT.10) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN TEN ',N
         RETURN
      END IF
      DO 1 I1=1,N-1
         II1=I1
         IF(I1.GE.I)II1=I1+1
         DO 2 I2=1,N-1
            II2=I2
            IF(I2.GE.J)II2=I2+1
 2          B(I1+(N-1)*(I2-1))=A(II1+N*(II2-1))
 1    CONTINUE
      MINOR=DETERM(B,N-1)
      RETURN
      END

      SUBROUTINE MINVR2(M1,M2)
      REAL*8 M1(3,3),M2(3,3),M3(3,3)
      DO 1 I=1,3
         DO 1 J=1,3
            M3(I,J)=M1(J,I)
 1    CONTINUE
      DO 2 I=1,3
         DO 2 J=1,3
            M2(I,J)=M3(I,J)
 2    CONTINUE
      RETURN
      END

      SUBROUTINE MINVRT(R1,R2)
      REAL*8 R1(9),R2(9)
      REAL*8 RTMP1(9)
C
      DO 1 I=1,9
 1       RTMP1(I)=R1(I)
C
C      CALL DINV(3,RTMP1,3,RTMP2,ICON)
         CALL MTXINV(RTMP1,3)
      DO 2 I=1,9
 2       R2(I)=RTMP1(I)
C
      RETURN
      END

      SUBROUTINE MMMULT(R1,R2,R3)
      REAL*8 R1(3,3),R2(3,3),R3(3,3),RDUMMY(3,3)
      CALL MEMCLR(RDUMMY,9,0)
      DO 1 I=1,3
         DO 2 J=1,3
            DO 3 K=1,3
 3             RDUMMY(I,J)=RDUMMY(I,J)+R1(I,K)*R2(K,J)
 2       CONTINUE
 1    CONTINUE
      DO 4 I=1,3
         DO 5 J=1,3
 5          R3(I,J)=RDUMMY(I,J)
 4    CONTINUE
C
      RETURN
      END

      SUBROUTINE MTXCLR(A,N)
      REAL*8 A(100)
      IF(N.GT.10) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN TEN ',N
         RETURN
      END IF
      DO 1 I12=1,N
         DO 1 I11=1,N
 1          A(I11+N*(I12-1))=0
      RETURN
      END

      SUBROUTINE MTXCPY(A,B,N)
      REAL*8 A(100),B(100)
      IF(N.GT.10) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN TEN ',N
         RETURN
      END IF
      DO 1 I12=1,N
         DO 1 I11=1,N
 1          B(I11+N*(I12-1))=A(I11+N*(I12-1))
      RETURN
      END

      SUBROUTINE MTXINV(A,N)
      REAL*8 A(100),B(100),DET,DETERM,MINOR
      IF(N.GT.10) THEN
         WRITE(6,*)' # ORDER IS GREATER THAN TEN ',N
         RETURN
      END IF
      CALL MTXCPY(A,B,N)
      DET=DETERM(A,N)
      DO 2 I3=1,N
         DO 2 I2=1,N
 2          A(I2+N*(I3-1))=(1-MOD(I3+I2,2)*2)*MINOR(B,N,I3,I2)/DET
      RETURN
      END

      SUBROUTINE MVMULT(R,P1,P2)
      REAL*8 R(3,3),P1(4),P2(4),PTMP(4)
C
      PTMP(1)=P1(1)*R(1,1)+P1(2)*R(1,2)+P1(3)*R(1,3)
      PTMP(2)=P1(1)*R(2,1)+P1(2)*R(2,2)+P1(3)*R(2,3)
      PTMP(3)=P1(1)*R(3,1)+P1(2)*R(3,2)+P1(3)*R(3,3)
      PTMP(4)=P1(4)
C
      P2(1)=PTMP(1)
      P2(2)=PTMP(2)
      P2(3)=PTMP(3)
      P2(4)=PTMP(4)
C
      RETURN
      END

      SUBROUTINE PBOOST(P,Q,PB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(4),Q(4),PB(4)
C
      PQ=P(1)*Q(1)+P(2)*Q(2)+P(3)*Q(3)
      Q2=Q(1)**2+Q(2)**2+Q(3)**2
      Q1=SQRT(Q2)
C
      AM=SQRT( (Q(4)-Q1)*(Q(4)+Q1) )
      F=((Q(4)-AM)*PQ/Q2+P(4))/AM
      PB(1)= P(1)+Q(1)*F
      PB(2)= P(2)+Q(2)*F
      PB(3)= P(3)+Q(3)*F
      PB(4)=(P(4)*Q(4)+PQ)/AM
      RETURN
      END

      SUBROUTINE ROTMTX(PAX, ROT)
* Debug 27/DEC/94 Y.Kurihara: To treat PAX(1)**2+PAX(2)**2=0
* Debug 04/Jan/95 Y.Kurihara: den>1.d-15 -->den>1.d-10 
*       19/Jan/95 Y.Kurihara: To treat phi rotation    
*
      IMPLICIT REAL* 8(A-H,O-Z)
      REAL*8 PAX(4)
      REAL*8 ROT(3,3),ROTTMP(3,3)
      den=SQRT(PAX(1)*PAX(1)+PAX(2)*PAX(2))
      if(den.le.1.d-10) then
         CALL MEMCLR(ROT,9,0)
         rot(1,1)=sign(1.d0,pax(3))
         rot(2,2)=sign(1.d0,pax(3))
         rot(3,3)=sign(1.d0,pax(3))
         return
      end if
      COSA=PAX(1)/den
      SINA=PAX(2)/den
      CALL MEMCLR(ROTTMP,9,0)
      ROTTMP(1,1)= COSA
      ROTTMP(1,2)= SINA
      ROTTMP(2,1)=-SINA
      ROTTMP(2,2)= COSA
      ROTTMP(3,3)= 1
      CALL MVMULT(ROTTMP,PAX,PAX)
      CALL MEMCLR(ROT,9,0)
      COSB=PAX(3)/SQRT(PAX(1)*PAX(1)+PAX(3)*PAX(3))
      SINB=PAX(1)/SQRT(PAX(1)*PAX(1)+PAX(3)*PAX(3))
      ROT(1,1)= COSB
      ROT(1,3)=-SINB
      ROT(2,2)= sign(1.d0,pax(3))
      ROT(3,1)= SINB
      ROT(3,3)= COSB
      CALL MMMULT(ROT,ROTTMP,ROT)
      RETURN
      END

      SUBROUTINE VVVMLT(P1,P2,P3)
      REAL*8 P1(0:3),P2(0:3),P3(0:3)
*FY 991027       P3(4)=0
      P3(1)=P1(2)*P2(3)-P1(3)*P2(2)
      P3(2)=P1(3)*P2(1)-P1(1)*P2(3)
      P3(3)=P1(1)*P2(2)-P1(2)*P2(1)
      RETURN
      END

      SUBROUTINE WTOLAB(P1,P2,P3, P4,P5)
* Debug 04/Jan/95 Y.Kurihara: To treat P3(1)**2+P3(2)**2=0
* Debug 04/Jan/95 Y.Kurihara: >1.d-15 --> >1.d-10
* Debug 25/Jan/95 Y.Kurihara: change to use rotmtx 
* mod   17/Apr/99 T.ISHIKAWA: no use MINVR2
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P1(4),P2(4),P3(4),P4(4),P5(4)
      DIMENSION ROT1(3,3),pt(4),ROTW(3,3)
C DETERMIN ROTATION MATRIX 1
      pt(1)=p3(1)
      pt(2)=p3(2)
      pt(3)=p3(3)
      pt(4)=p3(4)
      call rotmtx(pt, rot1)
*     CALL MINVR2(ROT1,ROT1)
*     CALL MINVR2(ROT1,ROTW)
      DO 1000 I=1,3
         DO 1000 J=1,3
            ROTW(I,J)=ROT1(J,I)
 1000 CONTINUE
      DO 2000 I=1,3
         DO 2000 J=1,3
            ROT1(I,J)=ROTW(I,J)
 2000 CONTINUE
C
      CALL MVMULT(ROT1,P1,P4)
      CALL MVMULT(ROT1,P2,P5)
      CALL PBOOST(P4,P3,P4)
      CALL PBOOST(P5,P3,P5)
C
      RETURN
      END


C---------------------------------
C Set Coupling for each particle.
C---------------------------------
      subroutine amparm
      implicit real*8(a-h,o-z)
*
      include 'inclm.h'
      include 'inclc.h'

* User Define
      include 'grchad.inc'

      complex*16 zr, zi
      save       zr, zi
      zr = dcmplx(1.0d0, 0.0d0)
      zi = dcmplx(0.0d0, 1.0d0)
*-----------------------------------------------------------------------
*     call sminit(   1,   1)
*-----------------------------------------------------------------------
* coupling constants
*
      zero      =   0.0d0
      one       =   1.0d0
      two       =   2.0d0
      three     =   3.0d0
      four      =   4.0d0
*
*  QED coupling constant
*
      r2        =   sqrt(two)
      r2i       =   one/r2

C==================================================
C...gauge invariant sets : (alpha, mw, mz)
C      ge2       =   four*pi*alpha

C...gauge invariant sets : (alpha0, gf, mw)
C      ge2       =   four*pi*alpha0

C...gauge invariant sets : (sin2W, gf, mw)
C      gf   = 1.16639d-5
C      sth2 = 0.231D0
C      alpha = sth2*r2*gf*amw**2/pi
C      ge2       =   four*pi*alpha

C...gauge invariant sets : (gf, mw, mz)
      gf   = 1.16639d-5
      sth2 = 1.0d0 - amw**2/amz**2
      alpha = sth2*r2*gf*amw**2/pi
      ge2       =   four*pi*alpha
C==================================================
      ge        =   sqrt(ge2)
      ge2h      =   ge2/two
      cqed      =   ge
*
*  Electric charges
*
      ql        = - one

C  Change the parameter for various grcflav

      qu        =   two/three
      qd        = - one/three

*
*  Electro-weak coupling constants
*
*   Gauge coupling constants
*
      amw2      =   amw**2
      amh2      =   amh**2

C==================================================
C...gauge invariant sets : (alpha, mw, mz)
C      gcos      =   amw/amz

C...gauge invariant sets : (alpha0, gf, mw)
C      gf   = 1.16639d-5
C      sth2 = pi*alpha0/r2/gf/amw2
C      cth2 = 1.0d0 - sth2
C      bmw2 = amw2
C      bmz2 = bmw2/cth2
C      bmw  = sqrt(bmw2)
C      bmz  = sqrt(bmz2)
C      gcos      =   bmw/bmz

C...gauge invariant sets : (sin2W, gf, mw)
C      cth2 = 1.0d0 - sth2
C      bmw2 = amw2
C      bmz2 = bmw2/cth2
C      bmw  = sqrt(bmw2)
C      bmz  = sqrt(bmz2)
C      gcos      =   bmw/bmz

C...gauge invariant sets : (gf, mw, mz)
      gcos      =   amw/amz
C==================================================

      gcos2     =   gcos**2
      gsin      =   sqrt(one-gcos2)
      gtan      =   gsin/gcos
      gcosi     =   one/gcos
      gcos2i    =   one/gcos2
      gcosd     =   two*gcos2 - one
*
      gg        =   ge/gsin
      gg2       =   gg**2
      ggh       =   gg/two
      gg2h      =   gg2/two
*
*   SSS and SSSS
      gs        =   gg *amh2/(two *amw )
      gs2       =   gg2*amh2/(four*amw2)
*
*   FFW
      gwfl      =   gg*r2i
*
*   FFA
      gal       =   ql*ge
*
      gau       =   qu*ge
      gad       =   qd*ge
*
*   FFZ
      gza       =   ggh*gcosi
      gzc       =   gg*gtan*gsin
*
      gznl      =   gza
*
      gzll      = - ql*gzc - gza
      gzlr      = - ql*gzc
*

C  Change the parameter for various grcflav for Z coupling

      gzul      = - qu*gzc + gza
      gzur      = - qu*gzc
*
      gzdl      = - qd*gzc - gza
      gzdr      = - qd*gzc
*
*   SFF
      gx        =   gg*r2i/amw
*
      g3        =   ggh/amw
*
*
*
* QCD coupling constants
*
      cqcd      =   sqrt(four*pi*alphas) 
*
*
*=======================================
* VVV
*---------------------------------------
      czww    = zr*( gg*gcos)
      caww    = zr*( ge)
      cggg    = zr*( cqcd)
*
*---------------------------------------
* VVVV
*---------------------------------------
      cwwaa    = zr*( ge2)
      cwwza    = zr*( ge*gg*gcos)
      cwwzz    = zr*( gg2*gcos2)
      cwwww    = zr*(-gg2)
      cgggg    = zr*( cqcd**2)
*
*---------------------------------------
* SSV
*---------------------------------------
      cwhm    = zi*( ggh)
      cwhp    = zi*( ggh)
      cwym    = zr*( ggh)
      cwyp    = zr*(-ggh)
      czpm    = zr*(-ggh*gcosd*gcosi)
      capm    = zr*(-ge)
      czhy    = zi*( ggh*gcosi)
*
*---------------------------------------
* SVV
*---------------------------------------
      chww    = zr*( gg*amw)
      chzz    = zr*( gg*amz*gcosi)
      cwzm    = zi*( ge*amz*gsin)
      cwam    = zi*(-ge*amw)
      cwzp    = zi*(-ge*amz*gsin)
      cwap    = zi*( ge*amw)
*
*---------------------------------------
* SSVV
*---------------------------------------
      cwwhh    = zr*( gg2h)
      czzhh    = zr*( gg2h*gcos2i)
      cwzhm    = zi*( ge2h*gcosi)
      cwzhp    = zi*(-ge2h*gcosi)
      cwahm    = zi*(-ge*ggh)
      cwahp    = zi*( ge*ggh)
      cwwyy    = zr*( gg2h)
      czzyy    = zr*( gg2h*gcos2i)
      cwzym    = zr*( ge2h*gcosi)
      cwzyp    = zr*( ge2h*gcosi)
      cwaym    = zr*(-ge*ggh)
      cwayp    = zr*(-ge*ggh)
      cwwpm    = zr*( gg2h)
      czzpm    = zr*( gg2h*(gcosd*gcosi)**2)
      caapm    = zr*( two*ge2)
      czapm    = zr*( ge*gg*gcosd*gcosi)
*
*---------------------------------------
* SSS
*---------------------------------------
      chpm    = zr*(-gs)
      chyy    = zr*(-gs)
*
      chhh    = zr*(-three*gs)
*
*---------------------------------------
* SSSS
*---------------------------------------
      chhhh    = zr*(-three*gs2)
      cyyyy    = zr*(-three*gs2)
      cpmyy    = zr*(-gs2)
      chhpm    = zr*(- gs2)
      chhyy    = zr*(-gs2)
      cpmpm    = zr*(-two*gs2)
*
      do 100 i = 1, 3
*---------------------------------------
* FFV (FFW : without quark mixing)
*---------------------------------------
         cwln(1,i) = zr*( gwfl)
         cwln(2,i) = zr*0
         cwnl(1,i) = zr*( gwfl)
         cwnl(2,i) = zr*0
         cwdu(1,i) = zr*( gwfl)
         cwdu(2,i) = zr*0
         cwud(1,i) = zr*( gwfl)
         cwud(2,i) = zr*0
*
*---------------------------------------
* FFV (FFA)
*---------------------------------------
         call(1,i) = zr*( gal)
         call(2,i) = zr*( gal)
         cauu(1,i) = zr*( gau)
         cauu(2,i) = zr*( gau)
         cadd(1,i) = zr*( gad)
         cadd(2,i) = zr*( gad)

*
*---------------------------------------
* FFV (FFZ)
*---------------------------------------
         cznn(1,i) = zr*( gznl)
         cznn(2,i) = zr*0
         czll(1,i) = zr*( gzll)
         czll(2,i) = zr*( gzlr)
*
         czuu(1,i) = zr*( gzul)
         czuu(2,i) = zr*( gzur)
         czdd(1,i) = zr*( gzdl)
         czdd(2,i) = zr*( gzdr)

*
*---------------------------------------
* FFV (FFg)
*---------------------------------------
*
         cguu(1,i) = zr*( cqcd)
         cguu(2,i) = zr*( cqcd)
         cgdd(1,i) = zr*( cqcd)
         cgdd(2,i) = zr*( cqcd)
*
*
*---------------------------------------
* XFF
*---------------------------------------
         cmln(1,i) = zi*( amlp(i)*gx)
         cmln(2,i) = zi*0
*
         cpnl(1,i) = zi*0
         cpnl(2,i) = zi*(-amlp(i)*gx)
*
         cmdu(1,i) = zi*( amdq(i)*gx)
         cmdu(2,i) = zi*(-amuq(i)*gx)
         cpud(1,i) = zi*( amuq(i)*gx)
         cpud(2,i) = zi*(-amdq(i)*gx)
*
*---------------------------------------
* HFF
*---------------------------------------
         chll(1,i) = zr*(-amlp(i)*g3)
         chll(2,i) = zr*(-amlp(i)*g3)
         chuu(1,i) = zr*(-amuq(i)*g3)
         chuu(2,i) = zr*(-amuq(i)*g3)
         chdd(1,i) = zr*(-amdq(i)*g3)
         chdd(2,i) = zr*(-amdq(i)*g3)
*
*
*---------------------------------------
* FFX3
*---------------------------------------
         cyll(1,i) = zi*(-amlp(i)*g3)
         cyll(2,i) = zi*( amlp(i)*g3)
         cyuu(1,i) = zi*( amuq(i)*g3)
         cyuu(2,i) = zi*(-amuq(i)*g3)
         cydd(1,i) = zi*(-amdq(i)*g3)
         cydd(2,i) = zi*( amdq(i)*g3)
 100  continue
*
*---------------------------------------
* CCV
*---------------------------------------
      cwczp    = zr*(-gg*gcos)
      cwcmz    = zr*( gg*gcos)
      cwcap    = zr*(-ge)
      cwcma    = zr*( ge)
      cwczm    = zr*( gg*gcos)
      cwcpz    = zr*(-gg*gcos)
      cwcam    = zr*( ge)
      cwcpa    = zr*(-ge)
      czcmm    = zr*(-gg*gcos)
      czcpp    = zr*( gg*gcos)
      cacmm    = zr*(-ge)
      cacpp    = zr*( ge)
*
      cgcgg    = zr*( cqcd)
*
*---------------------------------------
* SCC
*---------------------------------------
      cpczp    = zi*(-ggh*gcosd*amz)
      cpcap    = zi*(-ge*amw)
      cpcmz    = zi*( ggh*amz)
      cmczm    = zi*( ggh*gcosd*amz)
      cmcam    = zi*( ge*amw)
      cmcpz    = zi*(-ggh*amz)
      cycmm    = zi*(-ggh*amw)
      cycpp    = zi*( ggh*amw)
*
      chcmm    = zr*(-ggh*amw)
      chcpp    = zr*(-ggh*amw)
      chczz    = zr*(-ggh*gcosi*amz)

      if (grcflav.eq.0) then
      else if (grcflav.lt.13) then
         if (grcflav.eq.2.or.grcflav.eq.4
     $        .or.grcflav.eq.6.or.grcflav.eq.8
     $        .or.grcflav.eq.9.or.grcflav.eq.10) then
            cauu(1,1) = cadd(1,1)
            cauu(2,1) = cadd(2,1)
            czuu(1,1) = czdd(1,1)
            czuu(2,1) = czdd(2,1)
         endif
      else if (grcflav.lt.37) then
      else if (grcflav.lt.61) then
         if (grcflav.lt.53) then
            if (mod(grcflav,2).eq.0) then
               cauu(1,1) = cadd(1,1)
               cauu(2,1) = cadd(2,1)
               czuu(1,1) = czdd(1,1)
               czuu(2,1) = czdd(2,1)
            endif
         else if (grcflav.lt.57) then
            cauu(1,1) = cadd(1,1)
            cauu(2,1) = cadd(2,1)
            czuu(1,1) = czdd(1,1)
            czuu(2,1) = czdd(2,1)
         endif
      endif

*

*
      return
      end


*     File ammas2.f : Fri Jan 19 11:16:41 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine ammas2
      implicit real*8(a-h,o-z)

      include 'inclm.h'
*-----------------------------------------------------------------------
* mass**2
*-----------------------------------------------------------------------
      amw2 =    amw**2
      amz2 =    amz**2
      ama2 =    ama**2
      amg2 =    amg**2
      amg2 =    amg**2
      amg2 =    amg**2
      amh2 =    amh**2
      amx2 =    amx**2
      amy2 =    amy**2
      amnu2(1) = amnu(1)**2
      amnu2(2) = amnu(2)**2
      amnu2(3) = amnu(3)**2
      amlp2(1) = amlp(1)**2
      amlp2(2) = amlp(2)**2
      amlp2(3) = amlp(3)**2
      amuq2(1) = amuq(1)**2
      amuq2(2) = amuq(2)**2
      amuq2(3) = amuq(3)**2
      amdq2(1) = amdq(1)**2
      amdq2(2) = amdq(2)**2
      amdq2(3) = amdq(3)**2
      amcp2 =   amcp**2
      amcm2 =   amcm**2
      amcz2 =   amcz**2
      amca2 =   amca**2
      amcg2 =   amcg**2

      return
      end


*     File amkfcd.f : Fri Jan 19 11:16:41 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine amkfcd
      implicit real*8(a-h,o-z)

      include 'inclm.h'
      include 'inclc.h'
*-----------------------------------------------------------------------
      do 10 i = 1, 25
         amprtl(i) = -1.0d30
         agprtl(i) = -1.0d30
 10   continue

* mass as a function of KF-code
*
      amprtl(24) =    amw
      agprtl(24) =    agw
      amprtl(23) =    amz
      agprtl(23) =    agz
      amprtl(22) =    ama
      agprtl(22) =      0
      amprtl(21) =    amg
      agprtl(21) =      0

*** no KF-code for g4aux
*     amprtl(??) =    amg
*     agprtl(??) =      0


*** no KF-code for g41aux
*     amprtl(??) =    amg
*     agprtl(??) =      0

      amprtl(25) =    amh
      agprtl(25) =    agh

*** no KF-code for chi-plus
*     amprtl(??) =    amx
*     agprtl(??) =    agx

      amprtl(18) =    amy
      agprtl(18) =    agy
      amprtl(12) = amnu(1)
      agprtl(12) =      0
      amprtl(14) = amnu(2)
      agprtl(14) =      0
      amprtl(16) = amnu(3)
      agprtl(16) =      0
      amprtl(11) = amlp(1)
      agprtl(11) =      0
      amprtl(13) = amlp(2)
      agprtl(13) =      0
      amprtl(15) = amlp(3)
      agprtl(15) =      0
      amprtl( 2) = amuq(1)
      agprtl( 2) = aguq(1)
      amprtl( 4) = amuq(2)
      agprtl( 4) = aguq(2)
      amprtl( 6) = amuq(3)
      agprtl( 6) = aguq(3)
      amprtl( 1) = amdq(1)
      agprtl( 1) = agdq(1)
      amprtl( 3) = amdq(2)
      agprtl( 3) = agdq(2)
      amprtl( 5) = amdq(3)
      agprtl( 5) = agdq(3)

*** no KF-code for c-plus
*     amprtl(??) =   amcp
*     agprtl(??) =   agcp


*** no KF-code for c-minus
*     amprtl(??) =   amcm
*     agprtl(??) =   agcm


*** no KF-code for c-z
*     amprtl(??) =   amcz
*     agprtl(??) =   agcz


*** no KF-code for c-a
*     amprtl(??) =   amca
*     agprtl(??) =      0


*** no KF-code for c-g
*     amprtl(??) =   amcg
*     agprtl(??) =      0

      return
      end

*     File snprpd.f : Mon Apr  9 01:18:32 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine snprpd(pphase, aprop, amomq, amassq, amag)
      implicit real*8(a-h,o-z)
      complex*16 pphase, aprop
      real*8     amomq, amassq, amag
      common /chcntl/ jwidth, jtgamm
*
*    calculate denominator of propagator.
*
*     pphase : input  : phase of the propagator
*     aprop  : in/out : product of denominator of propagators.
*     amomp  : input  : square of mementum.
*     amassq : input  : square of mass.
*     amag   : input  : mass * width.
*-----------------------------------------------------------------------
      if (amomq .gt. 0) then
         if(jwidth .eq. 0) then
            if(amassq .eq. 0.0d0) then
               wid=0.d0
            else
               wid=amag/amassq*amomq
            end if
            aprop = pphase*aprop*dcmplx(amomq - amassq, wid)
         else
            aprop = pphase*aprop*dcmplx(amomq - amassq, amag)
         endif
      else
         aprop = pphase*aprop*dcmplx(amomq - amassq, 0.0d0)
      endif
 
*     call ctime('smprpd')

      return
      end

*     File spdetc(isel).f : Mon Apr  9 01:18:28 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine spdetc(isel)
      implicit real*8(a-h,o-z)
      include 'grchad.inc'
      common /amjprc/jproc
      integer isel

      if (igsub.eq.400) then
         call grc400detc(isel)
      else if (igsub.eq.401) then
         call grc401detc(isel)
      else if (igsub.eq.402) then
         call grc402detc(isel)
      else if (igsub.eq.403) then
         call grc403detc(isel)
      else if (igsub.eq.404) then
         call grc404detc(isel)
      else if (igsub.eq.405) then
         call grc405detc(isel)
      else if (igsub.eq.406) then
         call grc406detc(isel)
      else if (igsub.eq.407) then
         call grc407detc(isel)
      endif

      return
      end

C-----------------------------------------
C Set general parameters of each process.
C-----------------------------------------
C refference : GRACE User's manual
C              http://www-sc.kek.jp/minami/
C
C isub    : ID Number from PYTHIA
C jproc   : ID Number of Each Subprocess for GRACE
C
C ibswrt  : Write to output file ( = 0 )
C         : Already exist        ( = 1 )
C
C icoup      : Set Energy Scale (Coupling Q^2).
C              if icoup = 1  ==> Q^2 = s^ for parton scale.
C                       = 2  ==> Q^2 = average value of transverse mass^2.
C                       = 3  ==> Q^2 = total transverse mass^2.
C                       = 4  ==> Q^2 = maximum transverse mass^2.
C                       = 5  ==> Q^2 = constant value.
C                               (Set grcq in GeV order)
C                       = 6  ==> user defined Q^2
C
C grcfile : Output File Name of BASES
C grcproc : Define New Process for PYTHIA(pyupin)
C
C ndim    : Dimension of Integral
C ncall   : Number of Sampling Points per Iteration
C
C ndim =    2    +        (3n - 4)              +      (1 or 0)
C        (x1,x2)   (# of kinematical variables)    (degree of flavor)
C Example
C  +-------------+-------+-------+-------+-------+-------+-------+
C  |  Number of  |       |       |       |       |       |       |
C  | final state |   2   |   2   |   3   |   3   |   4   |   4   |
C  +=============+=======+=======+=======+=======+=======+=======+
C  |   Initial   |    _  |       |    _  |       |    _  |       |
C  |    State    |  q q' | gl gl |  q q' | gl gl |  q q' | gl gl |
C  +-------------+-------+-------+-------+-------+-------+-------+
C  |     ndim    |   5   |   4   |   8   |   7   |  11   |  10   |
C  +-------------+-------+-------+-------+-------+-------+-------+
      subroutine grcpypro(isub,grcfile,grcproc)
      implicit real*8(a-h,o-z)

      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL

      include 'grchad.inc'
      common /amjprc/jproc

      integer isub
      character grcfile*60,grcproc*60

      if (isub.eq.400) then
         jproc = 1
         ndim = 10
         grcproc = 'gg -> h0(bb)+bb(Higgs2,QCD2)'
      endif

      if (isub.eq.401) then
         jproc = 2
         ndim = 11
         grcproc = 'qq -> h0(bb)+bb(Higgs2,QCD2)'
      endif

      if (isub.eq.402) then
         jproc = 3
         ndim = 10
         grcproc = 'gg -> Z/A(bb)+bb(ELWK2,QCD2)'
      endif

      if (isub.eq.403) then
         jproc = 4
         ndim = 11
         grcproc = 'qq -> Z/A(bb)+bb(ELWK2,QCD2)'
      endif

      if (isub.eq.404) then
         jproc = 5
         ndim = 11
         grcproc = 'qq -> bbbb (Higgs2,ELWK2)'
      endif

      if (isub.eq.405) then
         jproc = 6
         ndim = 10
         grcproc = 'gg -> bbbb (QCD4)'
      endif

      if (isub.eq.406) then
         jproc = 7
         ndim = 11
         grcproc = 'qq -> bbbb (QCD4)'
      endif

      if (isub.eq.407) then
         jproc = 8
         ndim = 11
         grcproc = 'qq -> Z/A(bb)+Z/A(bb)(ELWK4)'
      endif

      call grcpar(isub,grcfile)

      return
      end


C--------------------------------------------
C Set kinematics parameters of each process.
C--------------------------------------------
C
C  Ktype = 1  : 2-2 process
C        = 2  : 3-body final state, Q^2 is NOT a resonance(glu/gam splitting). 
C        = 3  : 3-body final state, Q^2 is a resonance production(W+-, Z, top).
C        = 4  : 3-body final state, Fusion type (ex. 1->4+A, 2->5+B, A+B->3)
C        = 5  : 4-body final state, Q^2(ij) : reso., Q^2(kl) : non-reso..
C        = 6  : 4-body final state, Q^2(ij) : non-reso., Q^2(kl) : non-reso..
C        = 7  : 4-body final state, Q^2(ij) : reso., Q^2(kl) : reso..
C        = 8  : 4-body final state, Cascade Decay, (345) + 6 -> 3 + (45) + 6
C        = 9  : 4-body final state, Fusion type (ex. 1->5+A, 2->6+B, A+B->3+4)
C
C CXtype = 1  : 2-body final state  3 + 4        => Default
C        = 2  : 3-body final state, 3 + (45)     => Default
C        = 3  :                     4 + (35)
C        = 4  :                     5 + (34)
C        = 5  : 4-body final state, (34) + (56)  => Default
C        = 6  :                     (35) + (46)
C        = 7  :                     (36) + (45)
C        = 8  :                     (45) + (36)
C        = 9  :                     (46) + (35)
C        = 10 :                     (56) + (34)
C        = 11 :                     (345) + 6 -> 3 + (45) + 6
C        = 12 :                     (345) + 6 -> 4 + (35) + 6
C        = 13 :                     (345) + 6 -> 5 + (34) + 6
C        = 14 :                     (346) + 5 -> 3 + (46) + 5
C        = 15 :                     (346) + 5 -> 4 + (36) + 5
C        = 16 :                     (346) + 5 -> 6 + (34) + 5
C        = 17 :                     (356) + 4 -> 3 + (56) + 4
C        = 18 :                     (356) + 4 -> 5 + (36) + 4
C        = 19 :                     (356) + 4 -> 6 + (35) + 4
C        = 20 :                     (456) + 3 -> 4 + (56) + 3
C        = 21 :                     (456) + 3 -> 5 + (46) + 3
C        = 22 :                     (456) + 3 -> 6 + (45) + 3
C
      subroutine grcikin
      implicit real*8(a-h,o-z)

      include 'inclk.h'
      include 'grchad.inc'

      common /amjprc/jproc

C...Initialize of kinematical variables
      call grcival

      if (jproc.eq.1) then
         mxreg = 1
         ktype = 5
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 6
         gcos3(1) = 1
         gcos3(14) = 8
         gcon(1) = 3.0d-2
         gq12(1) = 1
         gq12(14) = 13

         gq22(1) = 1
         gq22(14) = 8
         gspr(1) = 2
         geps(1) = 9.5d-1
         gspr(2) = 2
         geps(2) = 5.0d-2
      endif

      if (jproc.eq.2) then
         mxreg = 1
         ktype = 8
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 1
         gyst(1) = 1
         gyst(14) = 6
         gcos3(1) = 1
         gcos3(14) = 1
         gq12(1) = 1
         gq12(14) = 13
         gq22(1) = 1
         gq22(14) = 1
      endif

      if (jproc.eq.3) then
         mxreg = 4
         ktype = 5
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 5
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 2
         gq12(3) = 80.0d0**2
         gq12(9) = 0.66d0
         gq12(14) = 4
         gq12(15) = 11
         gq22(1) = 1
         gq22(14) = 2
         gspr(1) = 1
         gspr(2) = 7
      endif

      if (jproc.eq.4) then
         mxreg = 4
         ktype = 5
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 2
         gq12(3) = 80.0d0**2
         gq12(9) = 0.4d0
         gq12(14) = 2
         gq12(15) = 11
         gq22(1) = 1
         gq22(14) = 2
      endif

      if (jproc.eq.5) then
         mxreg = 1
         ktype = 7
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 1
         gq12(1) = 1
         gq12(14) = 13
         gq22(1) = 1
         gq22(14) = 11
      endif

      if (jproc.eq.6) then
         mxreg = 2
         ktype = 6
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 5
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 1
         gq12(14) = 2
         gq22(1) = 1
         gq22(14) = 2
         gspr(1) = 2
         geps(1) = 5.0d-1
         gspr(2) = 2
         geps(2) = 5.0d-1
      endif

      if (jproc.eq.7) then
         mxreg = 2
         ktype = 6
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 5
         gyst(1) = 1
         gyst(14) = 1
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 1
         gq12(14) = 2
         gq22(1) = 1
         gq22(14) = 2
         gspr(1) = 2
         geps(1) = 7.0d-1
         gspr(2) = 2
         geps(2) = 7.0d-1
      endif

      if (jproc.eq.8) then
         mxreg = 2
         ktype = 7
         cxtype = 5

         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 2
         gq12(3) = 65.0d0**2
         gq12(9) = 0.05d0
         gq12(14) = 2
         gq12(15) = 11
         gq22(1) = 2
         gq22(3) = 65.0d0**2
         gq22(9) = 0.1d0
         gq22(14) = 2
         gq22(15) = 11
      endif

C...Set particle combination
      call grcspid

      return
      end


C-------------------
C Swap particle ID.
C-------------------
      subroutine grcswap(iset)
      implicit real*8(a-h,o-z)

      include 'grchad.inc'
      common /amjprc/jproc
      integer iset

      if (igsub.eq.400) then
      endif

      if (igsub.eq.401) then
      endif

      if (igsub.eq.402) then
         if (iset.eq.2) then
            call grcexkn(3,5)
            call grcexkn(4,6)
         else if (iset.eq.3) then
            call grcexkn(3,5)
         else if (iset.eq.4) then
            call grcexkn(4,6)
            call grcexkn(3,5)
         endif
      endif

      if (igsub.eq.403) then
         if (iset.eq.2) then
            call grcexkn(3,5)
            call grcexkn(4,6)
         else if (iset.eq.3) then
            call grcexkn(3,5)
         else if (iset.eq.4) then
            call grcexkn(4,6)
            call grcexkn(3,5)
         endif
      endif

      if (igsub.eq.404) then
      endif

      if (igsub.eq.405) then
         if (iset.eq.2) then
            call grcexkn(4,6)
         endif
      endif

      if (igsub.eq.406) then
         if (iset.eq.2) then
            call grcexkn(4,6)
         endif
      endif

      if (igsub.eq.407) then
         if (iset.eq.2) then
            call grcexkn(4,6)
         endif
      endif

      return
      end


C--------------------
C Set cross section.
C--------------------
      subroutine grcxset(isel)
      implicit real*8(a-h,o-z)

      common /amjprc/jproc
      include 'grchad.inc'
      include 'inclk.h'
      integer isel
      external drn

      if (igsub.eq.400) then
         call g400finit
         call grcffil
         isel = 1
      endif

      if (igsub.eq.401) then
         call g401finit
         call grcffil
         isel = 1
      endif

      if (igsub.eq.402) then
         call g402finit
         call grcffil
         grcsigsum = grcdsig(1)+grcdsig(2)+grcdsig(3)+grcdsig(4)

C         ransum = pyr(0)*grcsigsum
         ransum = drn(idummy)*grcsigsum

         isel = 0
         do while (ransum.gt.0.0d0)
            isel = isel + 1
            ransum = ransum - grcdsig(isel)
         enddo
      endif

      if (igsub.eq.403) then
         call g403finit
         call grcffil
         grcsigsum = grcdsig(1)+grcdsig(2)+grcdsig(3)+grcdsig(4)

C         ransum = pyr(0)*grcsigsum
         ransum = drn(idummy)*grcsigsum

         isel = 0
         do while (ransum.gt.0.0d0)
            isel = isel + 1
            ransum = ransum - grcdsig(isel)
         enddo
      endif

      if (igsub.eq.404) then
         call g404finit
         call grcffil
         isel = 1
      endif

      if (igsub.eq.405) then
         call g405finit
         call grcffil
         grcsigsum = grcdsig(1)+grcdsig(2)

C         ransum = pyr(0)*grcsigsum
         ransum = drn(idummy)*grcsigsum

         isel = 0
         do while (ransum.gt.0.0d0)
            isel = isel + 1
            ransum = ransum - grcdsig(isel)
         enddo
      endif

      if (igsub.eq.406) then
         call g406finit
         call grcffil
         grcsigsum = grcdsig(1)+grcdsig(2)

C         ransum = pyr(0)*grcsigsum
         ransum = drn(idummy)*grcsigsum

         isel = 0
         do while (ransum.gt.0.0d0)
            isel = isel + 1
            ransum = ransum - grcdsig(isel)
         enddo
      endif

      if (igsub.eq.407) then
         call g407finit
         call grcffil
         grcsigsum = grcdsig(1)+grcdsig(2)
C         ransum = pyr(0)*grcsigsum
         ransum = drn(idummy)*grcsigsum
         isel = 0
         do while (ransum.gt.0.0d0)
            isel = isel + 1
            ransum = ransum - grcdsig(isel)
         enddo
      endif

      return
      end
